diff --git a/python/plugins/GdalTools/GdalTools.py b/python/plugins/GdalTools/GdalTools.py
index d5d9893..914233c 100644
--- a/python/plugins/GdalTools/GdalTools.py
+++ b/python/plugins/GdalTools/GdalTools.py
@@ -264,11 +264,6 @@ class GdalTools:
     QObject.connect( self.settings, SIGNAL( "triggered()" ), self.doSettings )
     self.menu.addAction( self.settings )
 
-    menu_bar = self.iface.mainWindow().menuBar()
-    actions = menu_bar.actions()
-    lastAction = actions[ len( actions ) - 1 ]
-    menu_bar.insertMenu( lastAction, self.menu )
-
   def unload( self ):
     if not valid: return
     pass
diff --git a/src/app/qgisapp.cpp b/src/app/qgisapp.cpp
index 3d340ac..67752b5 100644
--- a/src/app/qgisapp.cpp
+++ b/src/app/qgisapp.cpp
@@ -1160,7 +1160,7 @@ void QgisApp::createMenus()
 #ifdef Q_WS_MAC
   // Window Menu
 
-  mWindowMenu = menuBar()->addMenu( tr( "&Window" ) );
+  mWindowMenu = new QMenu( tr( "&Window" ), this );
 
   mWindowMenu->addAction( mActionWindowMinimize );
   mWindowMenu->addAction( mActionWindowZoom );
@@ -1168,6 +1168,9 @@ void QgisApp::createMenus()
 
   mWindowMenu->addAction( mActionWindowAllToFront );
   mWindowMenu->addSeparator();
+
+  // insert before Help menu, as per Mac OS convention
+  menuBar()->insertMenu( mHelpMenu->menuAction(), mWindowMenu );
 #endif
 
   // Database Menu
@@ -5784,7 +5787,12 @@ void QgisApp::addPluginToDatabaseMenu( QString name, QAction* action )
       before = actions.at( i );
       break;
     }
-    else if ( actions.at( i )->menu() == mHelpMenu )
+    if ( actions.at( i )->menu() == mVectorMenu )
+    {
+      before = actions.at( i );
+      break;
+    }
+    if ( actions.at( i )->menu() == mRasterMenu )
     {
       before = actions.at( i );
       break;
@@ -5846,7 +5854,12 @@ void QgisApp::addPluginToWebMenu( QString name, QAction* action )
   {
     if ( actions.at( i )->menu() == mWebMenu )
       return;
-    if ( actions.at( i )->menu() == mHelpMenu )
+    if ( actions.at( i )->menu() == mVectorMenu )
+    {
+      before = actions.at( i );
+      break;
+    }
+    if ( actions.at( i )->menu() == mRasterMenu )
     {
       before = actions.at( i );
       break;
diff --git a/src/app/qgisapp.h b/src/app/qgisapp.h
index ba853fb..73e9027 100644
--- a/src/app/qgisapp.h
+++ b/src/app/qgisapp.h
@@ -333,12 +333,11 @@ class QgisApp : public QMainWindow, private Ui::MainWindow
     QMenu *vectorMenu() { return mVectorMenu; }
     QMenu *webMenu() { return mWebMenu; }
 #ifdef Q_WS_MAC
-    QMenu *firstRightStandardMenu() { return mWindowMenu; }
     QMenu *windowMenu() { return mWindowMenu; }
 #else
-    QMenu *firstRightStandardMenu() { return mHelpMenu; }
     QMenu *windowMenu() { return NULL; }
 #endif
+    QMenu *firstRightStandardMenu() { return mHelpMenu; }
     QMenu *printComposersMenu() {return mPrintComposersMenu;}
     QMenu *helpMenu() { return mHelpMenu; }
 
